Index: /code/trunk/src/orxonox/objects/WorldEntity.cc
===================================================================
--- /code/trunk/src/orxonox/objects/WorldEntity.cc	(revision 870)
+++ /code/trunk/src/orxonox/objects/WorldEntity.cc	(revision 871)
@@ -37,4 +37,5 @@
 #include "../Orxonox.h"
 #include "WorldEntity.h"
+#include "core/XMLPort.h"
 
 namespace orxonox
@@ -86,6 +87,7 @@
     void WorldEntity::loadParams(TiXmlElement* xmlElem)
     {
+
         BaseObject::loadParams(xmlElem);
-
+/*
         if (xmlElem->Attribute("position"))
         {
@@ -153,5 +155,32 @@
 
         create();
-
+*/
+    }
+
+    void WorldEntity::setYawPitchRoll(const Degree& yaw, const Degree& pitch, const Degree& roll)
+    {
+        this->yaw(yaw);
+        this->pitch(pitch);
+        this->roll(roll);
+    }
+
+    /**
+        @brief XML loading and saving.
+        @param xmlelement The XML-element
+        @param loading Loading (true) or saving (false)
+        @return The XML-element
+    */
+    void WorldEntity::XMLPort(Element& xmlelement, bool loading)
+    {
+        BaseObject::XMLPort(xmlelement, loading);
+
+        XMLPortParam(WorldEntity, "position", setPositionLoader2, getPosition, xmlelement, loading);
+        XMLPortParamLoadOnly(WorldEntity, "direction", setDirectionLoader, xmlelement, loading);
+        XMLPortParamLoadOnly(WorldEntity, "yawpitchroll", setYawPitchRoll, xmlelement, loading);
+        XMLPortParam(WorldEntity, "scale", setTotalScale, getScale, xmlelement, loading);
+        XMLPortParam(WorldEntity, "rotationAxis", setRotationAxisLoader, getRotationAxis, xmlelement, loading);
+        XMLPortParam(WorldEntity, "rotationRate", setRotationRate, getRotationRate, xmlelement, loading);
+
+        XMLPortObject(WorldEntity, WorldEntity, "attached", attachWorldEntity, getAttachedWorldEntity, xmlelement, loading);
     }
 
@@ -163,5 +192,5 @@
     void WorldEntity::registerAllVariables()
     {
-      // register coordinates
+/*      // register coordinates
       registerVar( (void*) &(this->getPosition().x), sizeof(this->getPosition().x), network::DATA);
       registerVar( (void*) &(this->getPosition().y), sizeof(this->getPosition().y), network::DATA);
@@ -171,5 +200,5 @@
       registerVar( (void*) &(this->getOrientation().x), sizeof(this->getOrientation().x), network::DATA);
       registerVar( (void*) &(this->getOrientation().y), sizeof(this->getOrientation().y), network::DATA);
-      registerVar( (void*) &(this->getOrientation().z), sizeof(this->getOrientation().z), network::DATA);
+      registerVar( (void*) &(this->getOrientation().z), sizeof(this->getOrientation().z), network::DATA);*/
       // not needed at the moment, because we don't have prediction yet
       /*// register velocity_
@@ -183,3 +212,16 @@
       registerVar( (void*) &(this->getRotationAxis().z), sizeof(this->getRotationAxis().z), network::DATA);*/
     }
+
+    void WorldEntity::attachWorldEntity(WorldEntity* entity)
+    {
+        this->attachedWorldEntities_.push_back(entity);
+    }
+
+    const WorldEntity* WorldEntity::getAttachedWorldEntity(unsigned int index)
+    {
+        if (index < this->attachedWorldEntities_.size())
+            return this->attachedWorldEntities_[index];
+        else
+            return 0;
+    }
 }
Index: /code/trunk/src/orxonox/objects/WorldEntity.h
===================================================================
--- /code/trunk/src/orxonox/objects/WorldEntity.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/WorldEntity.h	(revision 871)
@@ -8,7 +8,7 @@
 
 #include "util/Math.h"
+#include "util/XMLIncludes.h"
 #include "network/Synchronisable.h"
-#include "util/tinyxml/tinyxml.h"
-#include "../core/CoreIncludes.h"
+//#include "util/tinyxml/tinyxml.h"
 #include "core/BaseObject.h"
 #include "Tickable.h"
@@ -17,135 +17,157 @@
 namespace orxonox
 {
-  class _OrxonoxExport WorldEntity : public BaseObject, public Tickable, public network::Synchronisable
-  {
-    public:
-      WorldEntity();
-      virtual ~WorldEntity();
+    class _OrxonoxExport WorldEntity : public BaseObject, public Tickable//, public network::Synchronisable
+    {
+        public:
+            WorldEntity();
+            virtual ~WorldEntity();
 
-      virtual void tick(float dt);
-      virtual void loadParams(TiXmlElement* xmlElem);
-      bool create();
+            virtual void tick(float dt);
+            virtual void loadParams(TiXmlElement* xmlElem);
+            virtual void XMLPort(Element& xmlelement, bool loading);
+            bool create();
 
-      inline Ogre::SceneNode* getNode()
-          { return this->node_; }
+            void attachWorldEntity(WorldEntity* entity);
+            const WorldEntity* getAttachedWorldEntity(unsigned int index);
 
-      inline void setNode(Ogre::SceneNode* node)
-          { this->node_ = node; }
+            inline Ogre::SceneNode* getNode()
+                { return this->node_; }
 
-      inline void setPosition(const Vector3& pos)
-          { this->node_->setPosition(pos); }
-      inline void setPosition(Real x, Real y, Real z)
-          { this->node_->setPosition(x, y, z); }
-      inline const Vector3& getPosition() const
-          { return this->node_->getPosition(); }
+            inline void setNode(Ogre::SceneNode* node)
+                { this->node_ = node; }
 
-      inline void translate(const Vector3 &d, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_PARENT)
-          { this->node_->translate(d, relativeTo); }
-      inline void translate(Real x, Real y, Real z, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_PARENT)
-          { this->node_->translate(x, y, z, relativeTo); }
-      inline void translate(const Matrix3 &axes, const Vector3 &move, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_PARENT)
-          { this->node_->translate(axes, move, relativeTo); }
-      inline void translate(const Matrix3 &axes, Real x, Real y, Real z, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_PARENT)
-          { this->node_->translate(axes, x, y, z, relativeTo); }
+            inline void setPosition(const Vector3& pos)
+                { this->node_->setPosition(pos); }
+            inline void setPositionLoader1(const Vector3& pos)
+                { this->node_->setPosition(pos); }
+            inline void setPositionLoader2(Real x, Real y, Real z)
+                { this->node_->setPosition(x, y, z); }
+            inline void setPosition(Real x, Real y, Real z)
+                { this->node_->setPosition(x, y, z); }
+            inline const Vector3& getPosition() const
+                { return this->node_->getPosition(); }
 
-      inline void yaw(const Radian &angle, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_LOCAL)
-          { this->node_->yaw(angle, relativeTo); }
-      inline void pitch(const Radian &angle, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_LOCAL)
-          { this->node_->pitch(angle, relativeTo); }
-      inline void roll(const Radian &angle, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_LOCAL)
-          { this->node_->roll(angle, relativeTo); }
+            inline void translate(const Vector3 &d, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_PARENT)
+                { this->node_->translate(d, relativeTo); }
+            inline void translate(Real x, Real y, Real z, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_PARENT)
+                { this->node_->translate(x, y, z, relativeTo); }
+            inline void translate(const Matrix3 &axes, const Vector3 &move, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_PARENT)
+                { this->node_->translate(axes, move, relativeTo); }
+            inline void translate(const Matrix3 &axes, Real x, Real y, Real z, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_PARENT)
+                { this->node_->translate(axes, x, y, z, relativeTo); }
 
-      inline const Ogre::Quaternion& getOrientation()
-        { return this->node_->getOrientation(); }
-      inline void setOrientation(const Ogre::Quaternion& quat)
-        { this->node_->setOrientation(quat); }
-      inline void rotate(const Vector3 &axis, const Radian &angle, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_LOCAL)
-        { this->node_->rotate(axis, angle, relativeTo); }
-      inline void setDirection(Real x, Real y, Real z, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_LOCAL, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z)
-        { this->node_->setDirection(x, y, z, relativeTo, localDirectionVector); }
-      inline void setDirection(const Vector3 &vec, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_LOCAL, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z)
-        { this->node_->setDirection(vec, relativeTo, localDirectionVector); }
-      inline void lookAt(const Vector3 &targetPoint, Ogre::Node::TransformSpace relativeTo, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z)
-        { this->node_->lookAt(targetPoint, relativeTo, localDirectionVector); }
+            inline void yaw(const Radian &angle, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_LOCAL)
+                { this->node_->yaw(angle, relativeTo); }
+            inline void pitch(const Radian &angle, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_LOCAL)
+                { this->node_->pitch(angle, relativeTo); }
+            inline void roll(const Radian &angle, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_LOCAL)
+                { this->node_->roll(angle, relativeTo); }
+            void setYawPitchRoll(const Degree& yaw, const Degree& pitch, const Degree& roll);
 
-      inline void setScale(const Vector3 &scale)
-        { this->node_->setScale(scale); }
-      inline void setScale(Real x, Real y, Real z)
-        { this->node_->setScale(x, y, z); }
-      inline void setScale(Real scale)
-        { this->node_->setScale(scale, scale, scale); }
-      inline const Vector3& getScale(void) const
-        { return this->node_->getScale(); }
-      inline void scale(const Vector3 &scale)
-        { this->node_->scale(scale); }
-      inline void scale(Real x, Real y, Real z)
-        { this->node_->scale(x, y, z); }
-      inline void scale(Real scale)
-        { this->node_->scale(scale, scale, scale); }
+            inline void setYaw(const Degree &angle)
+                { this->node_->yaw(angle, Ogre::Node::TS_LOCAL); }
+            inline void setPitch(const Degree &angle)
+                { this->node_->pitch(angle, Ogre::Node::TS_LOCAL); }
+            inline void setRoll(const Degree &angle)
+                { this->node_->roll(angle, Ogre::Node::TS_LOCAL); }
 
-      inline void attachObject(Ogre::MovableObject *obj)
-        { this->node_->attachObject(obj); }
-      inline void attachObject(Mesh &mesh)
-        { this->node_->attachObject(mesh.getEntity()); }
-      inline void detachObject(Ogre::MovableObject *obj)
-        { this->node_->detachObject(obj); }
-      inline void detachAllObjects()
-        { this->node_->detachAllObjects(); }
+            inline const Ogre::Quaternion& getOrientation()
+              { return this->node_->getOrientation(); }
+            inline void setOrientation(const Ogre::Quaternion& quat)
+              { this->node_->setOrientation(quat); }
+            inline void rotate(const Vector3 &axis, const Radian &angle, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_LOCAL)
+              { this->node_->rotate(axis, angle, relativeTo); }
+            inline void setDirectionLoader(Real x, Real y, Real z)
+              { this->setDirection(x, y, z); }
+            inline void setDirection(Real x, Real y, Real z, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_LOCAL, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z)
+              { this->node_->setDirection(x, y, z, relativeTo, localDirectionVector); }
+            inline void setDirection(const Vector3 &vec, Ogre::Node::TransformSpace relativeTo=Ogre::Node::TS_LOCAL, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z)
+              { this->node_->setDirection(vec, relativeTo, localDirectionVector); }
+            inline void lookAt(const Vector3 &targetPoint, Ogre::Node::TransformSpace relativeTo, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z)
+              { this->node_->lookAt(targetPoint, relativeTo, localDirectionVector); }
 
-      inline void setVelocity(const Vector3& velocity)
-          { this->velocity_ = velocity; }
-      inline void setVelocity(Real x, Real y, Real z)
-          { this->velocity_.x = x; this->velocity_.y = y; this->velocity_.z = z; }
-      inline const Vector3& getVelocity() const
-          { return this->velocity_; }
+            inline void setScale(const Vector3 &scale)
+              { this->node_->setScale(scale); }
+            inline void setScale(Real x, Real y, Real z)
+              { this->node_->setScale(x, y, z); }
+            inline void setScale(Real scale)
+              { this->node_->setScale(scale, scale, scale); }
+            inline void setTotalScale(Real scale)
+              { this->node_->setScale(scale, scale, scale); }
+            inline const Vector3& getScale(void) const
+              { return this->node_->getScale(); }
+            inline void scale(const Vector3 &scale)
+              { this->node_->scale(scale); }
+            inline void scale(Real x, Real y, Real z)
+              { this->node_->scale(x, y, z); }
+            inline void scale(Real scale)
+              { this->node_->scale(scale, scale, scale); }
 
-      inline void setAcceleration(const Vector3& acceleration)
-          { this->acceleration_ = acceleration; }
-      inline void setAcceleration(Real x, Real y, Real z)
-          { this->acceleration_.x = x; this->acceleration_.y = y; this->acceleration_.z = z; }
-      inline const Vector3& getAcceleration() const
-          { return this->acceleration_; }
+            inline void attachObject(Ogre::MovableObject *obj)
+              { this->node_->attachObject(obj); }
+            inline void attachObject(Mesh &mesh)
+              { this->node_->attachObject(mesh.getEntity()); }
+            inline void detachObject(Ogre::MovableObject *obj)
+              { this->node_->detachObject(obj); }
+            inline void detachAllObjects()
+              { this->node_->detachAllObjects(); }
 
-      inline void setRotationAxis(const Vector3& axis)
-          { this->rotationAxis_ = axis; }
-      inline void setRotationAxis(Real x, Real y, Real z)
-          { this->rotationAxis_.x = x; this->rotationAxis_.y = y; this->rotationAxis_.z = z; }
-      inline const Vector3& getRotationAxis() const
-          { return this->rotationAxis_; }
+            inline void setVelocity(const Vector3& velocity)
+                { this->velocity_ = velocity; }
+            inline void setVelocity(Real x, Real y, Real z)
+                { this->velocity_.x = x; this->velocity_.y = y; this->velocity_.z = z; }
+            inline const Vector3& getVelocity() const
+                { return this->velocity_; }
 
-      inline void setRotationRate(const Radian& angle)
-          { this->rotationRate_ = angle; }
-      inline void setRotationRate(const Degree& angle)
-          { this->rotationRate_ = angle; }
-      inline const Radian& getRotationRate() const
-          { return this->rotationRate_; }
+            inline void setAcceleration(const Vector3& acceleration)
+                { this->acceleration_ = acceleration; }
+            inline void setAcceleration(Real x, Real y, Real z)
+                { this->acceleration_.x = x; this->acceleration_.y = y; this->acceleration_.z = z; }
+            inline const Vector3& getAcceleration() const
+                { return this->acceleration_; }
 
-      inline void setMomentum(const Radian& angle)
-          { this->momentum_ = angle; }
-      inline void setMomentum(const Degree& angle)
-          { this->momentum_ = angle; }
-      inline const Radian& getMomentum() const
-          { return this->momentum_; }
+            inline void setRotationAxisLoader(const Vector3& axis)
+                { this->rotationAxis_ = axis; }
+            inline void setRotationAxis(const Vector3& axis)
+                { this->rotationAxis_ = axis; }
+            inline void setRotationAxis(Real x, Real y, Real z)
+                { this->rotationAxis_.x = x; this->rotationAxis_.y = y; this->rotationAxis_.z = z; }
+            inline const Vector3& getRotationAxis() const
+                { return this->rotationAxis_; }
 
-      inline void setStatic(bool bStatic)
-          { this->bStatic_ = bStatic; }
-      inline bool isStatic()
-          { return this->bStatic_; }
+//            inline void setRotationRate(const Radian& angle)
+//                { this->rotationRate_ = angle; }
+            inline void setRotationRate(const Degree& angle)
+                { this->rotationRate_ = angle; this->setStatic(angle == Degree(0)); }
+            inline const Radian& getRotationRate() const
+                { return this->rotationRate_; }
 
-    protected:
-      void registerAllVariables();
+            inline void setMomentum(const Radian& angle)
+                { this->momentum_ = angle; }
+            inline void setMomentum(const Degree& angle)
+                { this->momentum_ = angle; }
+            inline const Radian& getMomentum() const
+                { return this->momentum_; }
 
-      Vector3 velocity_;
-      Vector3 acceleration_;
-      Vector3 rotationAxis_;
-      Radian rotationRate_;
-      Radian momentum_;
+            inline void setStatic(bool bStatic)
+                { this->bStatic_ = bStatic; }
+            inline bool isStatic()
+                { return this->bStatic_; }
 
-    private:
-      static unsigned int worldEntityCounter_s;
-      Ogre::SceneNode* node_;
-      bool bStatic_;
-  };
-  ExportClass(WorldEntity, Orxonox);
+        protected:
+            void registerAllVariables();
+
+            Vector3 velocity_;
+            Vector3 acceleration_;
+            Vector3 rotationAxis_;
+            Radian rotationRate_;
+            Radian momentum_;
+
+        private:
+            static unsigned int worldEntityCounter_s;
+            Ogre::SceneNode* node_;
+            bool bStatic_;
+            std::vector<WorldEntity*> attachedWorldEntities_;
+    };
 }
 
Index: /code/trunk/src/orxonox/objects/test1.cc
===================================================================
--- /code/trunk/src/orxonox/objects/test1.cc	(revision 870)
+++ /code/trunk/src/orxonox/objects/test1.cc	(revision 871)
@@ -29,7 +29,5 @@
 #include "test2.h"
 #include "test3.h"
-#include "util/tinyxml/tinyxml.h"
-#include "../Orxonox.h"
-#include <OgreSceneManager.h>
+#include "core/CoreIncludes.h"
 
 namespace orxonox
Index: /code/trunk/src/orxonox/objects/test2.cc
===================================================================
--- /code/trunk/src/orxonox/objects/test2.cc	(revision 870)
+++ /code/trunk/src/orxonox/objects/test2.cc	(revision 871)
@@ -29,4 +29,5 @@
 #include "test2.h"
 #include "test3.h"
+#include "core/CoreIncludes.h"
 
 namespace orxonox
Index: /code/trunk/src/orxonox/objects/test3.cc
===================================================================
--- /code/trunk/src/orxonox/objects/test3.cc	(revision 870)
+++ /code/trunk/src/orxonox/objects/test3.cc	(revision 871)
@@ -29,4 +29,5 @@
 #include "test2.h"
 #include "test3.h"
+#include "core/CoreIncludes.h"
 
 namespace orxonox
@@ -63,16 +64,16 @@
     void Test3::configOutput()
     {
-        std::cout << this->value_int_ << std::endl;
-        std::cout << this->value_uint_ << std::endl;
-        std::cout << (int)this->value_char_ << std::endl;
-        std::cout << (int)this->value_uchar_ << std::endl;
-        std::cout << this->value_float_ << std::endl;
-        std::cout << this->value_double_ << std::endl;
-        std::cout << this->value_bool_ << std::endl;
-        std::cout << this->value_string_ << std::endl;
-        std::cout << this->value_constchar_ << std::endl;
-        std::cout << this->value_vector2_ << std::endl;
-        std::cout << this->value_vector3_ << std::endl;
-        std::cout << this->value_colourvalue_ << std::endl;
+        std::cout << "int:         " << this->value_int_ << std::endl;
+        std::cout << "uint:        " << this->value_uint_ << std::endl;
+        std::cout << "char:        " << (int)this->value_char_ << std::endl;
+        std::cout << "uchar:       " << (int)this->value_uchar_ << std::endl;
+        std::cout << "float:       " << this->value_float_ << std::endl;
+        std::cout << "double:      " << this->value_double_ << std::endl;
+        std::cout << "bool:        " << this->value_bool_ << std::endl;
+        std::cout << "string:      " << this->value_string_ << std::endl;
+        std::cout << "constchar:   " << this->value_constchar_ << std::endl;
+        std::cout << "vector2:     " << this->value_vector2_ << std::endl;
+        std::cout << "vector3:     " << this->value_vector3_ << std::endl;
+        std::cout << "colourvalue: " << this->value_colourvalue_ << std::endl;
     }
 
Index: /code/trunk/src/orxonox/objects/test3.h
===================================================================
--- /code/trunk/src/orxonox/objects/test3.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/test3.h	(revision 871)
@@ -3,4 +3,5 @@
 
 #include "core/BaseObject.h"
+#include "util/Math.h"
 
 namespace orxonox
Index: /code/trunk/src/orxonox/objects/weapon/AmmunitionDump.cc
===================================================================
--- /code/trunk/src/orxonox/objects/weapon/AmmunitionDump.cc	(revision 870)
+++ /code/trunk/src/orxonox/objects/weapon/AmmunitionDump.cc	(revision 871)
@@ -31,4 +31,5 @@
 #include "BulletManager.h"
 #include "util/tinyxml/tinyxml.h"
+#include "core/CoreIncludes.h"
 
 #include "AmmunitionDump.h"
Index: /code/trunk/src/orxonox/objects/weapon/AmmunitionDump.h
===================================================================
--- /code/trunk/src/orxonox/objects/weapon/AmmunitionDump.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/weapon/AmmunitionDump.h	(revision 871)
@@ -37,5 +37,4 @@
 
 #include "network/Synchronisable.h"
-//#include "../core/CoreIncludes.h"
 #include "core/BaseObject.h"
 
@@ -66,5 +65,4 @@
     int *capacity_;
   };
-  ExportClass(AmmunitionDump, Orxonox);
 }
 
Index: /code/trunk/src/orxonox/objects/weapon/BarrelGun.cc
===================================================================
--- /code/trunk/src/orxonox/objects/weapon/BarrelGun.cc	(revision 870)
+++ /code/trunk/src/orxonox/objects/weapon/BarrelGun.cc	(revision 871)
@@ -38,4 +38,5 @@
 #include "AmmunitionDump.h"
 #include "BaseWeapon.h"
+#include "core/CoreIncludes.h"
 
 #include "BarrelGun.h"
Index: /code/trunk/src/orxonox/objects/weapon/BarrelGun.h
===================================================================
--- /code/trunk/src/orxonox/objects/weapon/BarrelGun.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/weapon/BarrelGun.h	(revision 871)
@@ -60,5 +60,4 @@
 
   };
-  ExportClass(BarrelGun, Orxonox);
 }
 
Index: /code/trunk/src/orxonox/objects/weapon/BaseWeapon.cc
===================================================================
--- /code/trunk/src/orxonox/objects/weapon/BaseWeapon.cc	(revision 870)
+++ /code/trunk/src/orxonox/objects/weapon/BaseWeapon.cc	(revision 871)
@@ -38,4 +38,5 @@
 #include "BulletManager.h"
 #include "AmmunitionDump.h"
+#include "core/CoreIncludes.h"
 
 #include "BaseWeapon.h"
Index: /code/trunk/src/orxonox/objects/weapon/BaseWeapon.h
===================================================================
--- /code/trunk/src/orxonox/objects/weapon/BaseWeapon.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/weapon/BaseWeapon.h	(revision 871)
@@ -122,5 +122,4 @@
 
   };
-  ExportAbstractClass(BaseWeapon, Orxonox);
 }
 
Index: /code/trunk/src/orxonox/objects/weapon/Bullet.cc
===================================================================
--- /code/trunk/src/orxonox/objects/weapon/Bullet.cc	(revision 870)
+++ /code/trunk/src/orxonox/objects/weapon/Bullet.cc	(revision 871)
@@ -27,4 +27,5 @@
 
 #include "OrxonoxStableHeaders.h"
+#include "core/CoreIncludes.h"
 
 #include "Bullet.h"
Index: /code/trunk/src/orxonox/objects/weapon/Bullet.h
===================================================================
--- /code/trunk/src/orxonox/objects/weapon/Bullet.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/weapon/Bullet.h	(revision 871)
@@ -47,5 +47,4 @@
     inline virtual void loadParams(TiXmlElement* xmlElem) { Model::loadParams(xmlElem); };
  };
-  ExportClass(Bullet, Orxonox);
 }
 
Index: /code/trunk/src/orxonox/objects/weapon/BulletManager.cc
===================================================================
--- /code/trunk/src/orxonox/objects/weapon/BulletManager.cc	(revision 870)
+++ /code/trunk/src/orxonox/objects/weapon/BulletManager.cc	(revision 871)
@@ -30,4 +30,5 @@
 #include "BulletManager.h"
 #include "Bullet.h"
+#include "core/CoreIncludes.h"
 
 
Index: /code/trunk/src/orxonox/objects/weapon/BulletManager.h
===================================================================
--- /code/trunk/src/orxonox/objects/weapon/BulletManager.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/weapon/BulletManager.h	(revision 871)
@@ -38,5 +38,4 @@
 #include "network/Synchronisable.h"
 #include "util/tinyxml/tinyxml.h"
-#include "../../core/CoreIncludes.h"
 #include "core/BaseObject.h"
 #include "../Tickable.h"
@@ -67,5 +66,4 @@
 	  int bulletsIndex_;
   };
-  ExportClass(BulletManager, Orxonox);
 }
 
Index: /code/trunk/src/orxonox/tools/BillboardSet.h
===================================================================
--- /code/trunk/src/orxonox/tools/BillboardSet.h	(revision 870)
+++ /code/trunk/src/orxonox/tools/BillboardSet.h	(revision 871)
@@ -7,6 +7,4 @@
 
 #include "../OrxonoxPrereqs.h"
-
-#include "../core/CoreIncludes.h"
 #include "util/Math.h"
 
Index: /code/trunk/src/orxonox/tools/Timer.cc
===================================================================
--- /code/trunk/src/orxonox/tools/Timer.cc	(revision 871)
+++ /code/trunk/src/orxonox/tools/Timer.cc	(revision 871)
@@ -0,0 +1,19 @@
+#include "core/CoreIncludes.h"
+#include "Timer.h"
+
+namespace orxonox
+{
+    /**
+        @brief Constructor: Sets the default-values.
+    */
+    TimerBase::TimerBase()
+    {
+        RegisterRootObject(TimerBase);
+
+        this->interval_ = 0;
+        this->bLoop_ = false;
+        this->bActive_ = false;
+
+        this->time_ = 0;
+    }
+}
Index: /code/trunk/src/orxonox/tools/Timer.h
===================================================================
--- /code/trunk/src/orxonox/tools/Timer.h	(revision 870)
+++ /code/trunk/src/orxonox/tools/Timer.h	(revision 871)
@@ -59,8 +59,5 @@
 
 #include <OgreFrameListener.h>
-
 #include "../OrxonoxPrereqs.h"
-
-#include "../core/CoreIncludes.h"
 
 namespace orxonox
@@ -72,15 +69,5 @@
 
         public:
-            /** @brief Constructor: Sets the default-values. */
-            TimerBase()
-            {
-                RegisterRootObject(TimerBase);
-
-                this->interval_ = 0;
-                this->bLoop_ = false;
-                this->bActive_ = false;
-
-                this->time_ = 0;
-            }
+            TimerBase();
 
             virtual void run() const = 0;
@@ -94,5 +81,5 @@
             /** @brief Unpauses the Timer - continues with the given state. */
             inline void unpauseTimer() { this->bActive_ = true; }
-            /** @returns true if the Timer is active (= not stoped, not paused). */
+            /** @brief Returns true if the Timer is active (= not stoped, not paused). @return True = Time is active */
             inline bool isActive() const { return this->bActive_; }
 
@@ -104,5 +91,4 @@
             float time_;        //!< Internal variable, counting the time till the next function-call
     };
-    ExportAbstractClass(TimerBase, Orxonox);
 
     //! The Timer is a callback-object, calling a given function after a given time-interval.
@@ -158,5 +144,4 @@
             T* object_;
     };
-    ExportAbstractClass(Timer<BaseObject>, Orxonox);
 
     //! The TimerFrameListener manages all Timers in the game.
Index: /code/trunk/src/util/CMakeLists.txt
===================================================================
--- /code/trunk/src/util/CMakeLists.txt	(revision 870)
+++ /code/trunk/src/util/CMakeLists.txt	(revision 871)
@@ -4,17 +4,21 @@
 
 SET (UTIL_SRC_FILES
+  Math.cc
+  String.cc
+  SubString.cc
+  MultiTypePrimitive.cc
+  MultiTypeString.cc
+  MultiTypeMath.cc
   ${TINYXML_SRC_FILES}
-  substring.cc
 )
 
-IF(WIN32)
-  ADD_LIBRARY( util ${UTIL_SRC_FILES} )
-ELSE(WIN32)
-  ADD_LIBRARY( util SHARED ${UTIL_SRC_FILES} )
-ENDIF(WIN32)
+ADD_LIBRARY( util SHARED ${UTIL_SRC_FILES} )
 SET_TARGET_PROPERTIES( util PROPERTIES LINK_FLAGS "--no-undefined" )
-
 
 IF(TESTING_ENABLED)
   ADD_SUBDIRECTORY(testing)
 ENDIF(TESTING_ENABLED)
+
+TARGET_LINK_LIBRARIES( util
+  ${OGRE_LIBRARIES}
+)
